From 3060feaa92bd94f4735420cefab1d286e15485bf Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Jun 30 2016 10:02:40 +0000
Subject: [PATCH 502/1001] Start porting hubs to OpenID-Connect from OpenID


---

diff --git a/hubs/app.py b/hubs/app.py
index 1f30e15..81c77d6 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -12,7 +12,7 @@ import munch
 import pygments.formatters
 import six
 
-from flask.ext.openid import OpenID
+from flask.ext.oidc import OpenIDConnect
 
 import fmn.lib
 import hubs.models
@@ -447,15 +447,12 @@ def widget_source(name):
 
 
 # Set up OpenID in stateless mode
-oid = OpenID(app,
-             safe_roots=[],
-             store_factory=lambda: None,
-             url_root_as_trust_root=True)
+FAS = OpenIDConnect(app, credentials_store=flask.session )
 
 
 @app.route('/login/', methods=('GET', 'POST'))
 @app.route('/login', methods=('GET', 'POST'))
-@oid.loginhandler
+@FAS.require_login
 def login():
     default = flask.url_for('index')
     next_url = flask.request.args.get('next', default)
@@ -530,21 +527,29 @@ def login_required(function):
 
 @app.before_request
 def check_auth():
+    flask.session.permanent = True
     flask.g.fedmsg_config = fedmsg_config
-    flask.g.auth = munch.Munch(logged_in=False)
-    if 'openid' in flask.session:
-        openid = flask.session.get('openid')
-        if isinstance(openid, six.binary_type):
-            openid = openid.decode('utf-8')
-        openid = openid.strip('/').split('/')[-1]
-        flask.g.auth.logged_in = True
-        flask.g.auth.openid = openid
-        flask.g.auth.user = hubs.models.User.by_openid(session, openid)
-        flask.g.auth.openid_url = flask.session.get('openid')
-        flask.g.auth.fullname = flask.session.get('fullname', None)
-        flask.g.auth.nickname = flask.session.get('nickname', None)
-        flask.g.auth.email = flask.session.get('email', None)
-        flask.g.auth.avatar = username2avatar(flask.g.auth.nickname)
+
+    if FAS.user_loggedin:
+        if not hasattr(flask.session, 'fas_user') or not flask.session.fas_user:
+            flask.session.auth = munch.Munch(
+                fullname=FAS.user_getfield('name'),
+                nickname=FAS.user_getfield('nickname'),
+                email=FAS.user_getfield('email'),
+                timezone=FAS.user_getfield('zoneinfo'),
+                cla_done=\
+                    'http://admin.fedoraproject.org/accounts/cla/done' \
+                    in FAS.user_getfield('cla'),
+                groups=FAS.user_getfield('groups'),
+                logged_in=True,
+            )
+            flask.session.auth.avatar=username2avatar(
+                flask.session.auth.nickname)
+            flask.session.auth.user = hubs.models.User.by_username(
+                session, flask.session.auth.nickname)
+        flask.g.auth = flask.session.auth
+    else:
+        flask.g.auth = munch.Munch(logged_in=False)
 
 
 def get_hub(session, name):
diff --git a/hubs/default_config.py b/hubs/default_config.py
index a21f138..b0d3eb7 100755
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -1,3 +1,5 @@
+import os
+
 SECRET_KEY = 'changemeforreal'
 
 PROMOTED_GROUPS = [
@@ -6,3 +8,11 @@ PROMOTED_GROUPS = [
 ]
 
 HUB_OF_THE_MONTH = 'commops'
+
+
+OIDC_CLIENT_SECRETS = os.path.join(os.path.dirname(
+    os.path.abspath(__file__)), '..', 'client_secrets.json')
+OIDC_ID_TOKEN_COOKIE_SECURE = False
+OIDC_REQUIRE_VERIFIED_EMAIL = False
+OIDC_OPENID_REALM = 'http://localhost:5000/oidc_callback'
+OIDC_SCOPES = ['openid', 'email', 'profile', 'fedora']

